package moe.oko.opennaw.model;

import moe.oko.opennaw.OpenNAW;
import net.kyori.adventure.text.Component;
import net.kyori.adventure.text.serializer.legacy.LegacyComponentSerializer;
import net.md_5.bungee.api.chat.TextComponent;
import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.Location;

public class City {
    private String name;
    private String resource;
    private CityState state;
    private Nation owner;
    private Location point;
    private short health;

    public City(String name, String resource, Location location) {
        this.name = name;
        this.resource = resource;
        //Default is unclaimed.
        this.owner = Nation.UNCLAIMED;
        this.state = CityState.NORMAL;
        this.point = location;
        this.health = 300;
    }

    public String getName() {
        return name;
    }

    public String getResource() {
        return resource;
    }

    public Nation getOwner() {
        return owner;
    }

    public void setOwner(Nation nation) {
        this.owner = nation;
        capture();
    }

    public Location getPoint() {
        return point;
    }

    public short getHealth() {
        return health;
    }

    public void damage(short damage) {
        this.health -= damage;
    }

    public void capture() {
        //This is our "capture" logic. So now we do shenanigans.
        if(OpenNAW.getInstance().isDynmapEnabled()) {
            //Dyn is enabled, we need to do setters.
            OpenNAW.getInstance().getDynmapHandler().updateCityInfoMarker(this);
        }
        Bukkit.broadcast(Component.text(ChatColor.AQUA + getName() + ChatColor.GOLD + " has been successfully captured by " + ChatColor.RED + this.owner.getName()));
    }

    public boolean isUnclaimed() {
        return owner == Nation.UNCLAIMED;
    }
}